'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.twoWayBind = exports.oneWayBind = undefined;

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

var _bind = require('./bind');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var oneWayBind = exports.oneWayBind = function oneWayBind() {
	var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'props';
	return function (target, name, descriptor) {
		var oldValue = descriptor.value;

		descriptor.value = function () {
			var oneWayBind = (0, _bind.oneWayBind)(this[props]);
			return oldValue.call(this, oneWayBind);
		};

		return descriptor;
	};
};

var twoWayBind = exports.twoWayBind = function twoWayBind() {
	var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'value';
	var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : ['onChangeText', 'onValueChange'];
	return function (target, name, descriptor) {
		var oldValue = descriptor.value;

		descriptor.value = function () {
			var twoWayBind = _bind.twoWayBind.apply(undefined, [value].concat(_toConsumableArray(event)))(this);
			return oldValue.call(this, twoWayBind);
		};

		return descriptor;
	};
};
//# sourceMappingURL=react-native-decorator.js.map