'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.twoWayBind = exports.oneWayBind = undefined;

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

var _bind = require('./bind');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var oneWayBind = exports.oneWayBind = function oneWayBind() {
	var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'props';
	return function (target, name, descriptor) {
		var oldValue = descriptor.value;

		descriptor.value = function () {
			var oneWayBind = (0, _bind.oneWayBind)(this[props]);
			return oldValue.call(this, oneWayBind);
		};

		return descriptor;
	};
};

var twoWayBind = exports.twoWayBind = function twoWayBind() {
	var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'value';
	var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'onChange';
	return function (target, name, descriptor) {
		var oldValue = descriptor.value;

		descriptor.value = function () {
			var twoWayBind = (0, _bind.twoWayBind)(value, event)(this);
			return oldValue.call(this, twoWayBind);
		};

		return descriptor;
	};
};
//# sourceMappingURL=react-decorator.js.map